with Interfaces.C.Strings; use Interfaces.C.Strings;
with Messages; use Messages;
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

package body Sessions is

  --Imports

  procedure Message_Transfer (Ses : Session; Destination : chars_ptr; Msg : Message);
  pragma Import (C_Plus_Plus, Message_Transfer, "_ZN8SessionC15MessageTransferEPKcR8MessageC");

  procedure Bind (Ses: Session; Queue_Name : chars_ptr; Exchange_Name : chars_ptr; Binding_Key : chars_ptr);
  pragma Import (C_Plus_Plus, Bind, "_ZN8SessionC4BindEPKcS1_S1_");

  procedure Exchange_Declare(Ses: Session; Exchange_Name : chars_ptr; Exchange_Type : chars_ptr; Alternate_Exchange : chars_ptr;
				Durable : Boolean; Auto_Delete : Boolean);
  pragma Import (CPP, Exchange_Declare, "_ZN8SessionC15ExchangeDeclareEPKcS1_S1_bb");

  procedure Exchange_Delete(Ses : Session; Exchange_Name : chars_ptr; If_Unused : Boolean);
  pragma Import (CPP, Exchange_Delete, "_ZN8SessionC14ExchangeDeleteEPKcb");

  procedure Unbind(Ses : Session; Exchange_Name : chars_ptr; Queue_Name : chars_ptr; Binding_Key : chars_ptr);
  pragma Import (CPP, Unbind, "_ZN8SessionC6UnbindEPKcS1_S1_");

  procedure Queue_Declare(Ses : Session; Queue_Name : chars_ptr; Alternate_Exchange : chars_ptr; Durable : Boolean;
			Exclusive : Boolean; Auto_Delete : Boolean);
  pragma Import (CPP, Queue_Declare, "_ZN8SessionC12QueueDeclareEPKcS1_bbb");

  procedure Queue_Delete(Ses : Session; Queue_Name : chars_ptr; If_Unused : Boolean);
  pragma Import (CPP, Queue_Delete, "_ZN8SessionC11QueueDeleteEPKcb");

  procedure Purge(Ses : Session; Queue_Name : chars_ptr);
  pragma Import (CPP, Purge, "_ZN8SessionC5PurgeEPKc");

  --Interfaces to imported functions
  procedure Message_Transfer (Ses : Session; Destination : Unbounded_String; Msg : Message) is
  begin
	Message_Transfer(Ses, New_String(To_String(Destination)), Msg);
  end Message_Transfer;   

  procedure Bind (Ses: Session; Queue_Name : Unbounded_String; Exchange_Name : Unbounded_String; Binding_Key : Unbounded_String)is
  begin
	Bind(Ses, New_String(To_String(Queue_Name)), New_String(To_String(Exchange_Name)), New_String(To_String(Binding_Key)));
  end Bind; 

  procedure Exchange_Declare(Ses: Session; Exchange_Name : Unbounded_String; Exchange_Type : Unbounded_String; Alternate_Exchange : 				     Unbounded_String; Durable : Boolean; Auto_Delete : Boolean) is
  begin
	Exchange_Declare(Ses, New_String(To_String(Exchange_Name)), New_String(To_String(Exchange_Type)),
			New_String(To_String(Alternate_Exchange)), Durable, Auto_Delete);
  end Exchange_Declare;
 
  procedure Exchange_Delete(Ses : Session; Exchange_Name : Unbounded_String; If_Unused : Boolean) is
  begin
	Exchange_Delete(Ses, New_String(To_String(Exchange_Name)), If_Unused);
  end Exchange_Delete;

  procedure Unbind(Ses : Session; Queue_Name : Unbounded_String; Exchange_Name : Unbounded_String; Binding_Key : Unbounded_String) is
  begin
	Unbind(Ses, New_String(To_String(Queue_Name)), New_String(To_String(Exchange_Name)), New_String(To_String(Binding_key)));
  end Unbind;

  procedure Queue_Declare(Ses : Session; Queue_Name : Unbounded_String; Alternate_Exchange : Unbounded_String; Durable : Boolean;
			Exclusive : Boolean; Auto_Delete : Boolean) is
  begin
	Queue_Declare(Ses, New_String(To_String(Queue_Name)), New_String(To_String(Alternate_Exchange)), Durable, Exclusive, Auto_Delete);
  end Queue_Declare;

  procedure Queue_Delete(Ses : Session; Queue_Name : Unbounded_String; If_Unused : Boolean) is
  begin
	Queue_Delete(Ses, New_String(To_String(Queue_Name)), If_Unused);
  end Queue_Delete;

  procedure Purge(Ses : Session; Queue_Name : Unbounded_String) is
  begin
	Purge(Ses, New_String(To_String(Queue_Name)));
  end Purge;

end Sessions;
